function [Vedge, Wedge] = IsNeighbour(V,W)
% Test whether two triangles are neighbouring.
% INPUT:
% V,W ... vectors of three indices of vertices
% OUTPUT:
% Vedge, Wedge ... both equal 0 if V and W are not neighbouring
%   otherwise V and W are neighbouring; and
%  Vedge and Wedge are then indices of the common edge;
%  Vedge is the edge in V and Wedge is the edge in W

Vedge = 0;
Wedge = 0;

k = 0;
for i = 1 : 3
  for j = 1 : 3
    if (V(i) == W(j))
      k = k + 1;
      match{k} = [i, j];
    end % if
  end % for j
end % for i

if (k == 3)
  error('Identical triangles');
end

if (k == 2)
  Vedge = 6 - match{1}(1) - match{2}(1);
  Wedge = 6 - match{1}(2) - match{2}(2);
end

end % function