function val = precompint()
% Precompute the integrals of barycentric coords into the global variable hpFEM_intlambda
% compute values intlamba(k,l,m) = int_T lmb_1^k lmb_2^l lmb_3^m / (2*area_T),
% where lmd are the barycentric coordinates,
% k,l,m are exponents (0,1,2,..., emax)
% T is a triangle
% NOTICE: The value intlambda(k,l,m) is the same for any triangle T.
% SEE: Strang, Fix, (1973), page 95

global hpFEM_intlambda
%persistent intlbdvals;

emax = 20; % limit for exponents

hpFEM_intlambda = zeros(emax+1,emax+1,emax+1);

%if isempty(intlbdvals)
  fprintf('Precomputing integrals ');
  for k=0:emax
    for l=0:emax
      for m=0:emax
        hpFEM_intlambda(k+1,l+1,m+1) = (factorial(k)*factorial(l)*factorial(m))/(factorial(k+l+m+2));
      end % for m
    end % for l
    fprintf('.');
  end % for k
  fprintf('done\n');
%end

%if (kk<0 || ll<0 || mm<0)
%  val = 0;
%else
%  val = intlbdvals(kk+1,ll+1,mm+1);
%end

%hpFEM_intlambda = zeros(emax+1,emax+1,emax+1);
% Remark: intlambda(k,l,m) is the same for
% any (out of six) permutation of exponents {k,l,m}.
% It is possible to save memory and time.

% save('hpFEM_intlambda.mat','hpFEM_intlambda');

end % function